/// <reference types="node" />
import { Application, Context, Server } from '@loopback/core';
import express from 'express';
import http from 'http';
export declare class RPCServer extends Context implements Server {
    app?: Application | undefined;
    config?: RPCServerConfig | undefined;
    private _listening;
    _server: http.Server;
    expressServer: express.Application;
    constructor(app?: Application | undefined, config?: RPCServerConfig | undefined);
    get listening(): boolean;
    start(): Promise<void>;
    stop(): Promise<void>;
}
export declare type RPCServerConfig = {
    port?: number;
    [key: string]: any;
};
