"use strict";
// Copyright IBM Corp. 2018,2020. All Rights Reserved.
// Node module: @loopback/example-rpc-server
// This file is licensed under the MIT License.
// License text available at https://opensource.org/licenses/MIT
Object.defineProperty(exports, "__esModule", { value: true });
exports.RPCServer = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@loopback/core");
const events_1 = require("events");
const express_1 = tslib_1.__importDefault(require("express"));
const rpc_router_1 = require("./rpc.router");
let RPCServer = class RPCServer extends core_1.Context {
    constructor(app, config) {
        super(app);
        this.app = app;
        this.config = config;
        this._listening = false;
        this.config = config !== null && config !== void 0 ? config : {};
        this.expressServer = (0, express_1.default)();
        (0, rpc_router_1.rpcRouter)(this);
    }
    get listening() {
        return this._listening;
    }
    async start() {
        var _a, _b;
        this._server = this.expressServer.listen((_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.port) !== null && _b !== void 0 ? _b : 3000);
        this._listening = true;
        await (0, events_1.once)(this._server, 'listening');
    }
    async stop() {
        this._server.close();
        this._listening = false;
        await (0, events_1.once)(this._server, 'close');
    }
};
RPCServer = tslib_1.__decorate([
    tslib_1.__param(0, (0, core_1.inject)(core_1.CoreBindings.APPLICATION_INSTANCE)),
    tslib_1.__param(1, (0, core_1.inject)('rpcServer.config')),
    tslib_1.__metadata("design:paramtypes", [core_1.Application, Object])
], RPCServer);
exports.RPCServer = RPCServer;
//# sourceMappingURL=rpc.server.js.map